using System;
using OgreDotNet;

namespace ExtendedCameraSample
{
	/// <summary>
	/// Summary description for Ogre.
	/// </summary>
	public class Ogre
	{
		protected Character mChar = null;
		protected ExtendedCamera mExCamera = null;
		protected ExtendedCamera.Mode mMode;

		public Ogre()
		{			
			mChar = null;
			mExCamera = null;
			mMode = 0;
		}

		public void setCharacter (Character character) 
		{
			mChar = character;
		}

		public void setExtendedCamera (ExtendedCamera cam) 
		{
			mExCamera = cam;
		}

		public void setCameraMode(ExtendedCamera.Mode camereraMode)
		{
			this.mMode = camereraMode;
		}

		public bool Update(float timeSinceLastFrame)
		{
			if (mChar!=null) 
			{
				mChar.update (timeSinceLastFrame);

				if (mExCamera!=null) 
				{
					switch (mMode) 
					{
						case ExtendedCamera.Mode.Chasing: // 3rd person chase
							mExCamera.update(timeSinceLastFrame, 
								mChar.getCameraNode().GetWorldPosition(), 
								mChar.getSightNode().GetWorldPosition());
							break;
						case ExtendedCamera.Mode.Fixed: // 3rd person fixed
							mExCamera.update(timeSinceLastFrame, 
								new Math3D.Vector3(0, 200, 0), 
								mChar.getSightNode().GetWorldPosition());
							break;
						case ExtendedCamera.Mode.FirstPerson: // 1st person
							mExCamera.update(timeSinceLastFrame, 
								mChar.getWorldPosition(), 
								//new Math3D.Vector3(mChar.getWorldPosition().x+5,mChar.getWorldPosition().y+15,mChar.getWorldPosition().z),
								mChar.getSightNode().GetWorldPosition ());
							break;
					}
				}
			}

			return true;

		}
	}
}
